
module count_buckets(
	input clock,
	input reset,
	input start,
	input stop,
	input re_enable,
	output reg [12:0] count
	);

reg[1:0] cstate;
parameter[1:0] cWait=0, cStart=1, cStop=2;
wire pegged = (count == 'hFFF);
always @ (posedge clock) begin
	if (reset) begin
		count <= 0;
		cstate <= cWait;
	end
	else 
		case (cstate)
			cWait: begin
				count <= 0;
				if (start) cstate <= cStart;
				else cstate <= cWait;
				end
			cStart: begin
				count <= count + 1;
				if	(pegged || stop) cstate <= cStop;
				else cstate <= cStart;
				end
			cStop: 
				if (re_enable) cstate <= cWait;
				else cstate <= cStop;
			default: begin
				cstate <= cWait;
				count <= 0;
				end
		endcase
	end

endmodule