module mac_control_send(sysclk,start,active,length,number,data,addr,cycle,strobe,
                     ack);
    input sysclk;
    input start;
    output active;
    input [10:0] length;
	 input [5:0] number;
    output [31:0] data;
    output [11:2] addr;
    output cycle, strobe;
    input ack;

	reg working;
	reg [5:0] packet_record;
	reg [10:0] length_record;

parameter MAX_PACKET=6'h7;

//		addr[11:2]<=10'h100; // really 0x400, but divided by 2
assign addr[11:9]=3'h2;
assign addr[8:3]=packet_record;
assign addr[2]=1'h0;
assign data[15:0]=(packet_record==MAX_PACKET)?(16'hb800):(16'h9800);
assign data[26:16]=length_record;
assign data[31:27]=5'h0;

always @(posedge sysclk)
	if (start && !working) begin
		packet_record<=number;
		length_record<=length;
	end

always @(posedge sysclk)
	if (start && !working) working<=1;
	else if (working && ack) working<=0;

assign cycle=working;
assign strobe=working;
assign active=working;

endmodule
